
*- Sample program to demonstrate usage of LOOKUP TABLES
*- SCROLLER() SCMOD() SMALLS()

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD


INITSUP()
SETCOLOR(C_NORMCOL)
if !(file("SFSAMPLE.DBF") .and. file("SFSAMPLE.DBT"))
        MSG("Need to be in the directory where","SFSAMPLE.DBF and SFSAMPLE.DBT are")
        quit
endif
USE SFSAMPLE
SAVE SCREEN TO LOOKSAM
SET CURSOR OFF
CLEAR
@ 0,0,24,79 BOX "Ŀ "
@ 3,79 SAY ''
@ 18,79 SAY ''
@ 1,17 SAY "[ Lookup Table Demonstration Program  ]"
@ 2,19 SAY "scroller() and scmod()"
@ 3,11 SAY ""
@ 5,13 SAY "Last Name"
@ 6,13 SAY "First Name"
@ 7,13 SAY "Middle Init"
@ 8,13 SAY "Address"
@ 9,13 SAY "City"
@ 10,13 SAY "State       [F2]"
@ 11,13 SAY "Zip"
@ 12,13 SAY "Product     [F2]"
@ 13,13 SAY "Amount Paid"
@ 14,13 SAY "Amount Due"
@ 15,13 SAY "Date of Sale"
@ 18,11 SAY ""
@ 19,14 SAY "* while editing or adding, press F2 where indicated"
@ 20,14 SAY "* for existing lookup table.  Press Alt-F2 to modify"
@ 21,14 SAY "* lookup table"
@ 0,0,24,10 BOX "Ŀ "
@ 0,10 SAY ""
@ 3,10 SAY ''
@ 16,0 SAY ''
@ 16,10 SAY ''
@ 18,10 SAY ''
@ 24,10 SAY ""
@ 16,1 SAY ""
@ 17,1 SAY "Record#"
@ 19,2 SAY ""
@ 20,1 SAY "Of"
@ 22,2 SAY ""
@5,33 get LNAME
@6,33 get FNAME
@7,33 get MI
@8,33 get ADDRESS
@9,33 get CITY
@10,33 get STATE
@11,33 get ZIP
@12,33 get PRODUCT
@13,33 get AMOUNTPAID pict "99999.99"
@14,33 get AMOUNTDUE pict "99999.99"
@15,33 get DATEOFSALE
clear gets
private ls_choice
do while .t.
     @ 18,1 SAY RECNO()
     @ 21,1 SAY RECC()
     @ 23,1 SAY IIF(DELETED(),"Deleted","       ")
     @3,2 PROMPT 'Next'
     @4,2 PROMPT 'Prior'
     @6,2 PROMPT 'Edit'
     @7,2 PROMPT 'Add'
     @8,2 PROMPT 'Browse'
     @9,2 PROMPT 'Quit'
     menu to ls_choice
     do case
        CASE ls_CHOICE = 1
            SKIP
            IF EOF()
             SKIP -1
            ENDIF
        CASE ls_CHOICE = 2
            SKIP -1
        CASE ls_CHOICE = 3
            looksam(.f.)
        CASE ls_CHOICE = 4
            looksam(.t.)
        CASE ls_CHOICE = 5
            EXTERNAL CRUNCH
            SMALLS("CRUNCH(LNAME+','+FNAME,0)","Sample Lookup with SMALLS()")
        CASE ls_CHOICE = 6
            close all
            fadeaway(looksam,0,0,24,79,30)
            SET CURSOR ON
            quit
     endcase
     @5,33 get LNAME
     @6,33 get FNAME
     @7,33 get MI
     @8,33 get ADDRESS
     @9,33 get CITY
     @10,33 get STATE
     @11,33 get ZIP
     @12,33 get PRODUCT
     @13,33 get AMOUNTPAID pict "99999.99"
     @14,33 get AMOUNTDUE pict "99999.99"
     @15,33 get DATEOFSALE
     clear gets
enddo

function looksam
EXTERNAL SCROLLER,SCMOD
SET KEY -1 TO SCROLLER
SET KEY -31 TO SCMOD
SET CURSOR ON
PARAM AD_ACTION
IF AD_ACTION
        LNAME=SPACE(20)
        FNAME=SPACE(15)
        MI=SPACE(1)
        ADDRESS=SPACE(35)
        CITY=SPACE(15)
        STATE=SPACE(2)
        ZIP=SPACE(5)
        PRODUCT=SPACE(10)
        AMOUNTPAID=0.00
        AMOUNTDUE=0.00
        DATEOFSALE=CTOD("  /  /  ")
ELSE
       LNAME=LNAME
       FNAME=FNAME
       MI=MI
       ADDRESS=ADDRESS
       CITY=CITY
       STATE=STATE
       ZIP=ZIP
       PRODUCT=PRODUCT
       AMOUNTPAID=AMOUNTPAID
       AMOUNTDUE=AMOUNTDUE
       DATEOFSALE=DATEOFSALE
ENDIF
@5,33 GET M->LNAME
@6,33 GET M->FNAME
@7,33 GET M->MI
@8,33 GET M->ADDRESS
@9,33 GET M->CITY
@10,33 GET M->STATE
@11,33 GET M->ZIP
@12,33 GET M->PRODUCT
@13,33 GET M->AMOUNTPAID pict "99999.99"
@14,33 GET M->AMOUNTDUE  pict "99999.99"
@15,33 GET M->DATEOFSALE
read
if !lastkey() = 27
   if messyn("Save this puppy?")
     IF ad_action
        append blank
     ENDIF
     replace LNAME with M->LNAME
     replace FNAME with M->FNAME
     replace MI with M->MI
     replace ADDRESS with M->ADDRESS
     replace CITY with M->CITY
     replace STATE with M->STATE
     replace ZIP with M->ZIP
     replace PRODUCT with M->PRODUCT
     replace AMOUNTPAID with M->AMOUNTPAID
     replace AMOUNTDUE with M->AMOUNTDUE
     replace DATEOFSALE with M->DATEOFSALE
   endif
endif
SET CURSOR OFF
SET KEY -1 TO
SET KEY -31 TO
return ''


