
*- Sample program to demonstrate usage of Pulldown Menu PULLDN()
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*- save screen
SAVE SCREEN TO SAMPLE


* draw screen
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("Pulldown Menu PULLDN()",78)
@ 3,1 SAY ""
@ 19,1 SAY ""
@ 23,6 SAY centr("Make a selection.....",60)

sf_choice = 1.01


*- menu choice definitions
*- 1. DECLARE SELECTIONS ARRAY TO # OF MENU BOXES
*--------------------------------------------------
PRIVATE choices[6]

*- 2. FILL EACH ELEMENT IN WITH THE BOX DEFINITION IN THE FORM:
*--------------------------------------------------
*       "BOX TITLE:Choice:Choice:Choice"
*     Using the colon (:) as the delimiter

choices[1] = "Files:Use Datafile:Define/Modify Datafile Definition:Copy records out:Append records in"
choices[2] = "Indexes:Select Indexes:Index order:New Index"
choices[3] = "Editing:VIEWPORT!:Global Field Replacement:Tabular Edit"
choices[4] = "Reporting:Build Query:Print Lists:Hunt Duplicates:Create Labels:Write Form Letters:Sum or Average a Field:DBF Field Frequency Analysis:Time Analysis:REPORT WRITER!"
choices[5] = "Other:List text file:Design Screen Appearance:Predefined Colors:Directory:Todo List:Calender:Solar Calculator"
choices[6] = "Quit:Quit:Author:Info:SuperFunction List"

*- 3. DEFINE THE LOOK AND FEEL OF THE MENU BOXES
*--------------------------------------------------
*     define an array of 7 elements to hold the menu descriptions
PRIVATE boxdata[7]

*     define the look and feel

boxdata[1] = .f.               && draw a box around the top bar?
boxdata[2] = m->c_normcol      && top bar color string
boxdata[3] = m->c_popmenu      && drop box color
boxdata[4] = m->c_frame        && drop box frame
boxdata[5] = 3                 && drop box shadow position (1,3,7,9,0)
boxdata[6] = m->c_shadatt      && drop box shadow attribute
boxdata[7] = 4                 && row # of top bar


*- 4. BE SURE TO GIVE A STARTING ELEMENT IN THE FORM #.##
*--------------------------------------------------------
sf_choice = 1.01       && BOX 1, CHOICE 01

do while .t.

        *- 5. CALL THE MENU HANDLER WITH THE ARRAYS AND STARTING ELEMENT,
        *     AND RECIEVE A CHOICE BACK
        *
        sf_choice = pulldn(m->sf_choice,m->choices,m->boxdata)

        MSG("You selected box "+trans(int(sf_choice),"99"),;
            "            item "+trans(((sf_choice-int(sf_choice))*100),"99"))
        if m->sf_CHOICE = 6.01  .or. m->sf_choice = 0  && quit
	    CLOSE ALL
	    exit
        endif
enddo
UNBOX(SAMPLE,0,0,24,79)





