
*- Sample program to demonstrate usage of MODIFY STRUCTURE
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD

*- save screen
SAVE SCREEN TO SAMPLE


*- initialize some variables
DECLARE INDEXES[8]
AFILL(m->indexes,"")
usedbf = ""

* draw screen
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("Modify Structure",78)
@ 3,1 SAY ""
@ 19,1 SAY ""
@ 23,6 SAY "Drive and Directory.."
@24,46 say "[F1 Help  Alt-F1 Modify Help]"

*- draw the center menu box
SETCOLOR(C_POPCOL)
BXX(5,24,16,52,STANDARD(), 1,7,"         ")

do while .t.

     *- display current drive/directory, dbfs and indexes
     SETCOLOR(C_NORMCOL)
     SCROLL(20,27,23,78,0)
     @23,27 SAY ADDSPACE(curd()+':\'+Curdir(),50)
     SETCOLOR(C_POPCOL)

     @7,27  PROMPT 'Change Directory     '
     @8,27  PROMPT 'List DBF Structure   '
     @9,27  PROMPT 'Modify DBF Structure '
     @12,27 PROMPT 'Quit                 '
     menu to sf_choice
     do case
	CASE m->sf_CHOICE = 1	 && change drive/directory
	    * check for change drive
	    OLDRIVE  = CURD()
	    CURDRIVE = m->oldrive
	    POPREAD(.f.,"Use Drive  :",@CURDRIVE,"!")
	    if !m->curdrive==m->oldrive
	      NEWDRV(m->curdrive)
	    endif
	    * run directory changer
	    IF FULLDIR()
	       USE
	    ENDIF

	CASE m->sf_CHOICE = 2	 && list dbf structure
            if adir("*.dbf") > 0
                USEDBF = POPEX("*.DBF","Select DBF")
                if !empty(m->usedbf)
		  USE (m->usedbf)
		  fc = fcount()
		  declare fnames[m->fc],ftypes[m->fc],flen[m->fc],fdec[m->fc]
		  afields(fnames,ftypes,flen,fdec)
		  declare structure[m->fc]
		  for i = 1 to fc
		     structure[m->i] = trans(m->i,"999")+"  "
		     structure[m->i] = structure[m->i]+addspace(fnames[m->i],15)
		     structure[m->i] = structure[m->i]+addspace(takeout("Character:Numeric:Logical:Date:Memo",":",AT(ftypes[m->i],"CNLDM")),10)
		     structure[m->i] = structure[m->i]+' '+trans(flen[m->i],"999")
		     structure[m->i] = structure[m->i]+' '+trans(fdec[m->i],"999")
		  next
		  mchoice(structure,2,2,22,78,"#    Field Names    Types      Lens  Decs")
                endif
            else
                *- message to user
		MSG("No DBFs detected in ",curd()+":\"+curdir())
	    endif

	CASE m->sf_CHOICE = 3	 && modify dbf structure
            if adir("*.dbf") > 0
		MODIFY()
            else
                *- message to user
		MSG("No DBFs detected in ",curd()+":\"+curdir())
	    endif

	CASE m->sf_CHOICE = 4  .or. m->sf_choice = 0  && quit
	    CLOSE ALL
	    exit
     endcase
enddo
UNBOX(SAMPLE,0,0,24,79)





