
*- Sample program to demonstrate usage of Super.Lib Popups
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD

*- save screen
SAVE SCREEN TO SAMPLE


* draw screen
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("Super.Lib Popups",78)
@ 3,1 SAY ""
@ 22,1 SAY ""
@ 23,6 SAY "Drive and Directory.."
@24,46 say "[F1 Help  Alt-F1 Modify Help]"

*- draw the center menu box
SETCOLOR(C_POPCOL)
BXX(5,24,19,52,STANDARD(), 1,7,"         ")
iswait = .f.
do while .t.

     *- display current drive/directory
     SETCOLOR(C_NORMCOL)
     SCROLL(23,27,23,78,0)
     @23,27 SAY ADDSPACE(curd()+':\'+Curdir(),50)
     SETCOLOR(C_POPCOL)

     @7,27  PROMPT 'Calender             '
     @8,27  PROMPT 'Solar Calculator     '
     @09,27 PROMPT 'Boxes    [makebox()] '
     @10,27 PROMPT 'Reads    [popread()] '
     @11,27 PROMPT 'File Selection       '
     @12,27 PROMPT 'Item Selection       '
     @13,27 PROMPT 'DBF Field Selection  '
     @14,27 PROMPT 'Printer Selection    '
     @15,27 PROMPT 'Message              '
     @16,27 PROMPT 'Yes/No Box           '
     @17,27 PROMPT 'Wait Box  '+iif(iswait,"OFF","ON ")
     @18,27 PROMPT 'Quit                 '
     menu to sf_choice
     do case
        CASE m->sf_CHOICE = 1    && calender
            GETDATE()
        CASE m->sf_CHOICE = 2    && calculator
            GETCALC()
        CASE m->sf_CHOICE = 3    && makebox/unbox
            boxsample()
        CASE m->sf_CHOICE = 4    && popread
            datef = date()
            numf = 123.45
            charf = "PREFONTAINE, GARRY"
            logf = .f.
            POPREAD(.t.,"Today's date:",@datef,"","Silly number",@numf,"$999.99","Worlds most dangerous developer:",@charf,"@K","Does a bear %$#! in the woods (Y/N)",@logf,"Y")
        CASE m->sf_CHOICE = 5    && popex
            filespec = space(12)
            popread(.f.,"Filespec :",@filespec,"@!")
            if !empty(m->filespec)
                afile = POPEX(TRIM(m->filespec),"Select a File")
                if !empty(m->afile)
                  MSG("You selected :",m->afile)
                endif
            endif
        CASE m->sf_CHOICE = 6    && mchoice
            private RAY[10]
            RAY[1]= "Blink"
            RAY[2]= "Link"
            RAY[3]= "Plink"
            RAY[4]= "Tlink"
            RAY[5]= "Warplink"
            RAY[6]= "RTlink"
            RAY[7]= "Optlink"
            RAY[8]= "Alink"
            RAY[9]= "Slink"
            RAY[10]= "Drink"
            CHOICE = mchoice(ray,10,10,20,40,"Linkers I've Known")
            if m->choice > 0
              MSG("You selected :",RAY[m->choice])
            endif
        CASE m->sf_CHOICE = 7    && mfields
	    if adir("*.dbf") > 0
		USEDBF = POPEX("*.DBF","Select DBF")
		if !empty(m->usedbf)
			USE (m->usedbf)
		endif
	    else
		*- message to user
		MSG("No DBFs detected in ",curd()+":\"+curdir())
	    endif
            afield = mfields("Pick a field")
            if !empty(m->afield)
                MSG("You selected :",m->afield)
            endif
            USE
        CASE m->sf_CHOICE = 8    && prnport, pready
            _SUPERPRN = PRNPORT()
            P_READY(_SUPERPRN)
        CASE m->sf_CHOICE = 9    && msg
            MSG( "Super.Lib Professional Library for Clipper",;
             "Written by ",;
             "  Garry A Prefontaine",;
             "  920 N Washington",;
             "  Edmond, Oklahoma, 73034",;
             "  (405) 340-1940",;
             "Copyright (c) 1989, Garry A Prefontaine")

        CASE m->sf_CHOICE = 10   && messyn
            IF MESSYN("Is Clipper 5.0 ready yet?")
              MSG("Sure it is...","Sure it is...")
            ENDIF
        CASE m->sf_CHOICE = 11 && wait box
            if m->iswait
                PLSWAIT(.f.)

                MSG("The cows have come home!")
            else
                PLSWAIT(.t.,"This box will sit here till the cows come home",19,2,21,78)
            endif
            iswait = !iswait
        CASE m->sf_CHOICE = 12 .or. m->sf_choice = 0  && quit
	    CLOSE ALL
	    exit
     endcase
enddo
UNBOX(SAMPLE,0,0,24,79)


function boxsample
oldcolor = setcolor()
private boxes[10]

boxes[1] = makebox(2,2,7,24, 'N/BG,N/W,,,BG+/N',0)
@ 3,6 SAY "BOX"

C_Shadpos=   3
C_Shadatt=     1
C_Frame=     "Ŀ "
boxes[2] = makebox(10,35,17,59,"N/B,N/W,,,BG+/N" )

C_Shadpos=   9
C_Shadatt=     1
boxes[3] = makebox(1,35,16,73,"N/B,N/W,,,BG+/N"  )
@ 3,49 SAY "BOX"

boxes[4] = makebox(10,4,21,23,'GR+/B,W+/R,,,W/R'  )
@ 15,10 SAY "BOX"

c_shadatt      =  24
boxes[5] = makebox(17,20,24,44,'N/W,+W/N,,,W/N'  )
@ 19,28 SAY "BOX"

C_Shadpos=   7
C_Shadatt=     8
C_Frame=     "͸Գ "
boxes[6] = makebox(4,55,11,79,"GR+/N,GR+/R,,,N/R"  )
@ 7,63 SAY "BOX"

c_shadatt      =  116
boxes[7] = makebox(4,17,11,41,'W+/R,GR+/B,,,W/B'  )
@ 7,25 SAY "BOX"

C_Shadpos=   1
C_Shadatt=   121
C_Frame=     "Ŀ "
boxes[8] = makebox(13,4,18,66,"BG+/N,BG/B,,,N/W" )
@ 15,24 SAY "BOX"

C_Shadpos=   1
C_Shadatt=     3
C_Frame=     "Ŀ "
boxes[10] = makebox(19,55,23,70,"W+/W,GR+/N,,,G/N"  )
@ 21,60 SAY "BOX"

c_shadatt      =  24
boxes[9] = makebox(9,35,16,59,'N/BG,RB+/N,,,W+/RB'  )
@ 12,39 SAY "PRESS A KEY ..."
inkey(0)
for i = 10 to 1 step -1
   unbox(boxes[m->i])
next
setcolor(m->oldcolor)


