
*- Sample program to demonstrate usage of Super.Lib Screen and Color Control
*-

*- set up Super.Lib Global variables
INITSUP()

*- initialize default color to C_NORMCOL
SETCOLOR(C_NORMCOL)

* set statuses
SET TALK OFF
SET ECHO OFF
SET CONFIRM OFF
SET BELL OFF
SET SAFETY OFF
SET SCOREBOARD OFF
SET TYPEAHEAD TO 50


*-setup help system
EXTERNAL HELP,HELPMOD
SET KEY 28 TO HELP
SET KEY -30 to HELPMOD

*- save screen
SAVE SCREEN TO SAMPLE


* draw screen
drawscreen()



iswait = .f.
do while .t.

     *- display current drive/directory
     SETCOLOR(C_NORMCOL)
     SCROLL(23,27,23,78,0)
     @23,27 SAY ADDSPACE(curd()+':\'+Curdir(),50)
     SETCOLOR(C_POPCOL)

     @7,27  PROMPT 'Free-form Color Setting '
     @8,27  PROMPT 'Pre-defined Colors   '
     @09,27 PROMPT 'Clear Screen with Character'
     @10,27 PROMPT 'Numeric Color settings '
     @11,27 PROMPT 'Dissolve Restore Screen '
     @12,27 PROMPT 'Slide Restore Screen'
     @14,27 PROMPT 'Quit                 '
     menu to sf_choice
     do case
        CASE m->sf_CHOICE = 1    &&  'Free-form Color Setting '
            SETCOLORS()
            RESTORE FROM COLORS.MEM ADDIT
            DRAWSCREEN()
        CASE m->sf_CHOICE = 2    &&  'Pre-defined Colors   '
            COLPIK()
            RESTORE FROM COLORS.MEM ADDIT
            DRAWSCREEN()
        CASE m->sf_CHOICE = 3    &&  'Clear Screen with Character'
            ccolor = 78        && yellow on read
            cchar = chr(177)   && 
            popread(.f.,"Color to clear screen with (numeric)  :",@ccolor,"999","Character to clear screen with ",@cchar,"")
            CLS(ccolor,cchar)
            INKEY(1)
            drawscreen()
        CASE m->sf_CHOICE = 4    &&  'Query color settings '
            MSG("Current SETCOLOR() is  "+setcolor(),;
                "Standard() returns     "+trans(standard(),"999"),;
                "Enhanced() returns     "+trans(enhanced(),"999"),;
                "Unselected() returns   "+trans(unselected(),"999"))
        CASE m->sf_CHOICE = 5    &&  'Dissolve Restore Screen '
            fadeaway(m->sample,0,0,24,79,40)
            inkey(1)
            drawscreen()
        CASE m->sf_CHOICE = 6    &&  'Slide Restore Screen'
           shiftr(m->sample,0,0,24,79,3)
            inkey(1)
            drawscreen()
        CASE m->sf_CHOICE = 7    &&  'Quit                 '
	    exit
     endcase
enddo
UNBOX(SAMPLE,0,0,24,79)


function drawscreen
SETCOLOR(C_NORMCOL)
CLEAR
@ 0,0,24,79 BOX "ͻȺ "
@ 3,0 SAY ''
@ 3,79 SAY ''
@ 19,0 SAY ''
@ 19,79 SAY ''
@ 1,16 SAY "Super.Lib Professional Demonstration Program"
@ 2,1 SAY CENTR("Super.Lib Screen and Color Control",78)
@ 3,1 SAY ""
@ 22,1 SAY ""
@ 23,6 SAY "Drive and Directory.."
@24,46 say "[F1 Help  Alt-F1 Modify Help]"

*- draw the center menu box
SETCOLOR(C_POPCOL)
BXX(5,20,15,56,STANDARD(), 1,7,"         ")


